﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Media;

namespace Controls
{
  public static class Utility
  {
    public static T GetParent<T>(DependencyObject obj) where T : DependencyObject
    {
      DependencyObject parent = VisualTreeHelper.GetParent(obj);
      while (parent != null) {
        if (parent.GetType() == typeof(T))
          return (T)parent;
        parent = VisualTreeHelper.GetParent(parent);
      }
      return null;
    } // GetParent

    public static IEnumerable<T> GetChildren<T>(DependencyObject obj) where T : DependencyObject
    {
      int childCount = VisualTreeHelper.GetChildrenCount(obj);
      for (int i = 0; i < childCount; i++) {
        DependencyObject child = VisualTreeHelper.GetChild(obj, i);
        if (child.GetType() == typeof(T))
          yield return (T)child;
        else {
          foreach (T c in GetChildren<T>(child))
            yield return c;
        }
      }
    } // GetChildren
  }
}
