﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Core;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

namespace HamburgerMenuNavigationUWP
{
  public sealed partial class MainPage : Page
  {
    public static string StartPage = "HamburgerMenuNavigationUWP.Pages.HomePage";

    public MainPage()
    {
      this.InitializeComponent();
    }

    public Grid MainGrid
    {
      get { return m_Grid; }
    }

    public bool IsPaneOpen
    {
      get { return m_SplitView.IsPaneOpen; }
      set { m_SplitView.IsPaneOpen = value; }
    }

    public Controls.MenuButton SelectedMenu
    {
      get
      {
        foreach (Controls.MenuButton mb in Controls.Utility.GetChildren<Controls.MenuButton>(m_SplitView)) {
          if (mb.Selected)
            return mb;
        }
        return null;
      }
    }

    public bool SelectMenu(string actionName)
    {
      bool res = false;
      foreach (Controls.MenuButton mb in Controls.Utility.GetChildren<Controls.MenuButton>(m_SplitView)) {
        mb.Selected = actionName.Equals(mb.ActionName, StringComparison.OrdinalIgnoreCase);
        if (mb.Selected)
          res = true;
      }
      return res;
    }

    private void HamburgerButton_Tapped(object sender, TappedRoutedEventArgs e)
    {
      m_SplitView.IsPaneOpen = !m_SplitView.IsPaneOpen;
    }

    private void MenuButton_Tapped(object sender, TappedRoutedEventArgs e)
    {
      Controls.MenuButton mb = sender as Controls.MenuButton;
      if (mb != null) {
        if (!string.IsNullOrEmpty(mb.ActionName)) {
          Type pt = Type.GetType(mb.ActionName);
          if (pt != null)
            Frame.Navigate(pt);
        }
      }
    }
  }
}
