﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Core;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Media.Animation;
using Windows.UI.Xaml.Navigation;

namespace HamburgerMenuNavigationUWP.Pages
{
  public class NavigationArgs
  {
    public NavigationMode NavigationMode { get; set; }
    public System.Object Parameter { get; set; }
    public Type SourcePageType { get; set; }
  } // NavigationArgs

  public abstract class BasePage : Page
  {
    Transition m_ForwardEnterTransition = new EdgeUIThemeTransition() { Edge = EdgeTransitionLocation.Right };
    Transition m_ForwardExitTransition = new EdgeUIThemeTransition() { Edge = EdgeTransitionLocation.Left };

    Transition m_BackEnterTransition = new EdgeUIThemeTransition() { Edge = EdgeTransitionLocation.Left };
    Transition m_BackExitTransition = new EdgeUIThemeTransition() { Edge = EdgeTransitionLocation.Right };

    public Transition ForwardEnterTransition {
      get { return m_ForwardEnterTransition; }
      set { m_ForwardEnterTransition = value; }
    }

    public Transition ForwardExitTransition
    {
      get { return m_ForwardExitTransition; }
      set { m_ForwardExitTransition = value; }
    }

    public Transition BackEnterTransition
    {
      get { return m_BackEnterTransition; }
      set { m_BackEnterTransition = value; }
    }

    public Transition BackExitTransition
    {
      get { return m_BackExitTransition; }
      set { m_BackExitTransition = value; }
    }

    public new Frame Frame
    {
      get
      {
        Page p = (Window.Current.Content as Frame).Content as Page;
        if (p != null)
          return p.Frame;
        return null;
      }
    }

    public string SelectMenuAction{ get; set; }

    public new virtual void OnNavigatingFrom(NavigatingCancelEventArgs e)
    {

    }

    public virtual void OnNavigatedTo(NavigationArgs e)
    {

    }

    public virtual void OnNavigatedFrom(NavigationArgs e)
    {

    }

    public virtual void OnBackRequested(object sender, BackRequestedEventArgs e)
    {
      // Override this to manage the back request in your page.
    }
  }
}
