﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Threading.Tasks;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Animation;
using Windows.UI.Xaml.Navigation;

namespace HamburgerMenuNavigationUWP.Pages
{
  public sealed partial class DataPage : BasePage
  {
    public class DataItem
    {
      public string Name { get; set; }
      public string Description { get; set; }
      public int Value { get; set; }
    }

    public DataPage()
    {
      this.InitializeComponent();

      NavigationCacheMode = NavigationCacheMode.Required;      
    }

    ~DataPage()
    {
      System.Diagnostics.Debug.WriteLine("DataPage disposed");
    }

    public override async void OnNavigatedTo(NavigationArgs e)
    {
      base.OnNavigatedTo(e);

      ForwardExitTransition = new EdgeUIThemeTransition() { Edge = EdgeTransitionLocation.Left };
      BackEnterTransition = new EdgeUIThemeTransition() { Edge = EdgeTransitionLocation.Left };

      if (m_List.ItemsSource != null)
        return;

      m_ProgressRoing.IsActive = true;
      await Task.Delay(2000);

      List<DataItem> items = new List<DataItem>();
      int itmesCount = 1000;
      for (int i=0; i< itmesCount; i++) {
        items.Add(new DataItem()
        {
          Name = string.Format("Item name {0}/{1}", i + 1, itmesCount),
          Description = string.Format("Description for item {0}/{1}", i + 1, itmesCount),
          Value = i + 1
        });
      }
      m_List.ItemsSource = items;

      m_ProgressRoing.IsActive = false;
    }

    private void m_List_ItemClick(object sender, ItemClickEventArgs e)
    {
      ForwardExitTransition = new EdgeUIThemeTransition() { Edge = EdgeTransitionLocation.Bottom };
      BackEnterTransition = new EdgeUIThemeTransition() { Edge = EdgeTransitionLocation.Bottom };
      Frame.Navigate(typeof(DataDetailsPage), e.ClickedItem);
    }
  }
}
